# Wargames Overhaul
### A visual-only, client-side-only mod for Wargames.
#### Image previews can be found below the Settings section.

<hr>

<br>

> ## **Contact:**
> ### In case of any crashes and/or questions ping me (S2ymi#6601) on the Official Northstar Discord in the #modding-chat channel

<br>

# Changelog:

## v1.0.0:

- Kill-Reactive Walls with customisable colours
- No Grid on the Walls
- Custom Nebula Skybox
- Custom Colour Correction
- Custom Loadscreen
- Removed part of the Skybox Models
- Changed texture of the Grid outside of the map
- Settings regarding most of the features

<hr>

# Settings:

##### All Colour settings have an Intensity setting next to them so it's best to set each of the RGB channels to a number between 0 and 1 and later control the brightness with the Intensity setting.

### Post-Processing:

- Bloom Scale
- Map Fog
- Sky Light Tint
   - None is what base game uses
- Colour Correction Amount
   - Range: 0-1
- Colour Correction Strength

### Walls:

##### Wall 1 is the cyan one in vanilla, Wall 2 is the orange one.

- Base Colour Intensity
   - Recommended values are around 5
   - 0 makes the walls fully transparent
- Wall 1 Base Colour
- Wall 2 Base Colour
- Kill Reactive Walls On/Off
- Wall 1 Kill Colour
- Wall 2 Kill Colour
- Kill Transition type
   - Linear and Logarithmic go from Kill Colour to Base Colour
   - Quadratic goes from Base to Kill in 1/2 of the specified time and back to Base again within the second half
- Logarithmic Transition Coefficient
   - Only affects the Logarithmic Transition Type
   - The lower this is the more curved the log function is (Colour transition is faster)
   - Basically becomes linear above values of 5
   - Not recommended to go below 0.2
- Kill Colour Intensity
   - Also Changes according to the Kill Transition Type
- Kill Colour Transition Time
   - In seconds
- Walls Flicker Toggle
   - Works by multiplying the current intensity by a random number between `1 - Flicker Deviation` and `1 + Flicker Deviation`
- Walls Flicker Deviation
   - Describes the maximum random amount by which the intensity should deviate
- Walls Flicker Deviation Power
   - Power to raise the randomly generated number to
- RGB Walls Cycle
   - RGB
   - :D

### Grid

- Colour
- Intensity
- RGB Cycle
   - Will sync with RGB Walls if they're enabled
   - RGB
   - :D

<hr>

# Preview:

![image](https://cdn.discordapp.com/attachments/974722927704539166/1005185176164372571/unknown.png)

<br>

![image](https://cdn.discordapp.com/attachments/974722927704539166/1005184479763124335/unknown.png)

<br>

![image](https://cdn.discordapp.com/attachments/974722927704539166/1005185873761009664/unknown.png)

<br>

![image](https://cdn.discordapp.com/attachments/974722927704539166/1005186334442393751/unknown.png)

<br>

![image](https://cdn.discordapp.com/attachments/974722927704539166/1005184858181611551/unknown.png)

<br>

![image](https://cdn.discordapp.com/attachments/974722927704539166/1005185005900808222/unknown.png)

<br>

![image](https://cdn.discordapp.com/attachments/974722927704539166/1005185662229676165/unknown.png)

<br>
<hr>
<br>

![image](https://cdn.discordapp.com/attachments/974722927704539166/1005186989416513607/unknown.png)

![image](https://cdn.discordapp.com/attachments/974722927704539166/1005187043049091072/unknown.png)

<p align="center">Map Fog On and Off</p>

<br>
<hr>
<br>

![image](https://cdn.discordapp.com/attachments/974722927704539166/1005187043049091072/unknown.png)

![image](https://cdn.discordapp.com/attachments/974722927704539166/1005187178277642411/unknown.png)

![image](https://cdn.discordapp.com/attachments/974722927704539166/1005187238885330997/unknown.png)

<p align="center">Magenta, Cyan and No Tint</p>

<br>
<hr>
<br>

![image](https://cdn.discordapp.com/attachments/974722927704539166/1005187932807774338/unknown.png)

![image](https://cdn.discordapp.com/attachments/974722927704539166/1005187882924908605/unknown.png)

<p align="center">Weak and Strong Colour Correction</p>

<hr>