untyped
global function wargamesOverhaulPrecache
global function wargamesOverhaulSettings

void function wargamesOverhaulSettings(){
    #if UI
        #if S2_WG_OH_GLITCH_P_FIX
            try{
                printt("[S2.WGOH] Client has the Glitch Particle Fix ConVar set to: " + GetConVarString("glitch_oh_p_has_wg_fix"))
            }
            catch(ex){
                thread noParticleFixThread()
            }
        #else
            printt("[S2.WGOH] Client doesn't have use GlitchOverhaul, no fix required.")
        #endif


        #if S2_WG_OH_MOD_SETTINGS
            //      Post processing
            AddConVarSettingEnum("s2_wgoh_bloom_scale", "Bloom Scale", "S2.WargamesOverhaul Post-Processing", ["0 (None)", "1 (Base game)", "2 (High)", "3 (Very High)"])
            AddConVarSettingEnum("s2_wgoh_map_fog", "Map Fog", "S2.WargamesOverhaul Post-Processing", ["Off", "On"])
            AddConVarSettingEnum("s2_wgoh_map_tint", "Sky Light Tint", "S2.WargamesOverhaul Post-Processing", ["None", "Magenta", "Cyan", "Black"])
            AddConVarSetting("s2_wgoh_cc_weight", "Colour Correction Amount", "S2.WargamesOverhaul Post-Processing", "float")
            AddConVarSettingEnum("s2_wgoh_cc_entities", "Colour Correction Strength", "S2.WargamesOverhaul Post-Processing", ["Weak", "Strong"])

            //      Base
            AddConVarSetting("s2_wgoh_base_intensity", "Base Colour Intensity", "S2.WargamesOverhaul Walls", "float")
            AddConVarSetting("s2_wgoh_wall_1_col", "Wall 1 Base Colour", "S2.WargamesOverhaul Walls", "vector")
            AddConVarSetting("s2_wgoh_wall_2_col", "Wall 2 Base Colour", "S2.WargamesOverhaul Walls", "vector")

            //      Kill
            AddConVarSettingEnum("s2_wgoh_kill_reactive", "Kill Reactive Walls", "S2.WargamesOverhaul Walls", ["Off", "On"])
            AddConVarSetting("s2_wgoh_wall_1_kill_col", "Wall 1 Kill Colour", "S2.WargamesOverhaul Walls", "vector")
            AddConVarSetting("s2_wgoh_wall_2_kill_col", "Wall 2 Kill Colour", "S2.WargamesOverhaul Walls", "vector")
            AddConVarSettingEnum("s2_wgoh_kill_type", "Kill Transition Type", "S2.WargamesOverhaul Walls", ["Linear", "Logarithmic", "Quadratic"])
            AddConVarSetting("s2_wgoh_kill_log_coeff", "Logarithmic Transition Coefficient", "S2.WargamesOverhaul Walls", "float")
            AddConVarSetting("s2_wgoh_kill_intensity", "Kill Colour Intensity", "S2.WargamesOverhaul Walls", "float")
            AddConVarSetting("s2_wgoh_kill_time", "Kill Colour Transition Time", "S2.WargamesOverhaul Walls", "float")

            //      Misc
            AddConVarSettingEnum("s2_wgoh_walls_flicker", "Flicker Toggle", "S2.WargamesOverhaul Walls", ["Off", "On"])
            AddConVarSetting("s2_wgoh_flicker_deviation", "Flicker Deviation", "S2.WargamesOverhaul Walls", "float")
            AddConVarSetting("s2_wgoh_flicker_power", "Flicker Deviation Power", "S2.WargamesOverhaul Walls", "int")
            AddConVarSettingEnum("s2_wgoh_rgb_walls", "Walls RGB Cycle", "S2.WargamesOverhaul Walls", ["Off", "On"])

            //      Grid
            AddConVarSetting("s2_wgoh_grid_colour", "Outside Grid Colour", "S2.WargamesOverhaul Grid", "vector")
            AddConVarSetting("s2_wgoh_grid_intensity", "Outside Grid Intensity", "S2.WargamesOverhaul Grid", "float")
            AddConVarSettingEnum("s2_wgoh_grid_rgb", "Outside Grid RGB Cycle", "S2.WargamesOverhaul Grid", ["Off", "On"])
            
        #else
            thread noSettingsDiagThread()
        #endif

        #if S2_WG_OH_KILL_CALLBACK
            printt("[S2.WGOH] Client has all dependencies intstalled!")
        #else
            thread noCallbackThread()
        #endif
    #endif
}

void function wargamesOverhaulPrecache(){
    #if S2_WG_OH_KILL_CALLBACK
        #if CLIENT
            AddCallback_OnPlayerKilled(WGOH_kill)
            AddCallback_EntitiesDidLoad(WGOH_main)
            thread RegisterCC()
        #endif
    #endif
}

#if UI
void function noSettingsDiagThread(){
    WaitFrame()
    noSettingsDiag()
}

void function noSettingsDiag(){
    DialogData errorPopUp
    errorPopUp.header = "MISSING REQUIRED DEPENDENCY"
    errorPopUp.message = "WargamesOverhaul requires ModSettings to function.\nThe mod was not found; please download it."
    errorPopUp.image = $"ui/menu/common/dialog_error"
    AddDialogButton(errorPopUp, "Exit", void function(){ ClientCommand("exit") })
    AddDialogButton(errorPopUp, "Download", void function(){
        LaunchExternalWebBrowser("https://northstar.thunderstore.io/package/EladNLG/ModSettings/", WEBBROWSER_FLAG_FORCEEXTERNAL)
        noSettingsDiag()
    })
    OpenDialog(errorPopUp)
}

void function noCallbackThread(){
    WaitFrame()
    noCallbackDiag()
}

void function noCallbackDiag(){
    DialogData errorPopUp
    errorPopUp.header = "MISSING REQUIRED DEPENDENCY"
    errorPopUp.message = "WargamesOverhaul requires S2.ClientKillCallback to function.\nThe mod was not found; please download it."
    errorPopUp.image = $"ui/menu/common/dialog_error"
    AddDialogButton(errorPopUp, "Exit", void function(){ ClientCommand("exit") })
    AddDialogButton(errorPopUp, "Download", void function(){
        LaunchExternalWebBrowser("https://northstar.thunderstore.io/package/S2Mods/ClientKillCallback/", WEBBROWSER_FLAG_FORCEEXTERNAL)
        noSettingsDiag()
    })
    OpenDialog(errorPopUp)
}

void function noParticleFixThread(){
    WaitFrame()
    noParticleFixDiag()
}

void function noParticleFixDiag(){
    DialogData errorPopUp
    errorPopUp.header = "GlitchOverhaul Version Error"
    errorPopUp.message = "You're running an outdated version of GlitchOverhaul!\n\nIf you wish to use WargamesOverhaul and GlitchOverhaul at once you must update to the newest version of GlitchOverhaul."
    errorPopUp.image = $"ui/menu/common/dialog_error"
    AddDialogButton(errorPopUp, "Exit", void function(){ ClientCommand("exit") })
    AddDialogButton(errorPopUp, "Update", void function(){
        LaunchExternalWebBrowser("https://northstar.thunderstore.io/package/S2Mods/GlitchOverhaul/", WEBBROWSER_FLAG_FORCEEXTERNAL)
        noSettingsDiag()
    })
    OpenDialog(errorPopUp)
}
#endif

#if CLIENT

vector function GetConVarFloat3(string convar){
    array<string> value = split(GetConVarString(convar), " ")
    try{
        return Vector(value[0].tofloat(), value[1].tofloat(), value[2].tofloat()) 
    }
    catch(ex){
        throw "Invalid convar " + convar + "! make sure it is a float3 and formatted as \"X Y Z\""
    }
    unreachable
}

float function logAnyDecrease(float x, float coefficient){
    if(coefficient > 0.0){
        float k = (1.0/coefficient)
        float b = -(1.0/(pow(2.71828, k) - 1.0))
        float c = (1.0 + (coefficient * log(1.0/(pow(2.71828, k) - 1.0))))
        return ((coefficient * (-1.0) * (log(x - b))) + c)
    }
    else{
        return -1.0
    }
    unreachable
}

float function quadraticDecrease(float x){
    return ((-4 * (x - 0.5) * (x - 0.5)) + 1)
}

float function flickerPowerFunc(float input, int power){
    float result = input
    for(int i = 1; i < power; i++)
        result *= input
    return result
}

int function GetFlickerPower(){
    int power = GetConVarInt("s2_wgoh_flicker_power")
    if(power >= 1)
        return power
    else{
        SetConVarInt("s2_wgoh_flicker_power", 2)
        throw "Invalid input, Flicker Deviation Power can't be below 1!"
    }
    unreachable
}

float function GetLogCoefficient(){
    float input = GetConVarFloat("s2_wgoh_kill_log_coeff")
    if(input > 0)
        return input
    else{
        SetConVarFloat("s2_wgoh_kill_log_coeff", 0.5)
        throw "Invalid input, Logarithmic Transition Coefficient can't be below or equal to 0!"
    }
    unreachable
}

void function SetWallColours(vector wallOneColour, vector wallTwoColour){
    SetConVarFloat("s2_wgoh_vmt_1_r", wallOneColour.x)
    SetConVarFloat("s2_wgoh_vmt_1_g", wallOneColour.y)
    SetConVarFloat("s2_wgoh_vmt_1_b", wallOneColour.z)
    SetConVarFloat("s2_wgoh_vmt_2_r", wallTwoColour.x)
    SetConVarFloat("s2_wgoh_vmt_2_g", wallTwoColour.y)
    SetConVarFloat("s2_wgoh_vmt_2_b", wallTwoColour.z)
}

void function SetGridColour(vector gridCol){
    SetConVarFloat("s2_wgoh_vmt_grid_r", gridCol.x)
    SetConVarFloat("s2_wgoh_vmt_grid_g", gridCol.y)
    SetConVarFloat("s2_wgoh_vmt_grid_b", gridCol.z)
}

var wargamesCC = null

void function RegisterCC(){
    WaitFrame()
    wargamesCC = ColorCorrection_Register("materials/correction/wargames_custom_cc.raw")
}

float killStartTime = 0.0

void function WGOH_kill(entity victim, entity attacker, int damageSourceId){
    if(attacker != GetLocalClientPlayer())
        return
    if(attacker == null || !IsValid(attacker))
        return
    killStartTime = Time()
}

string oldMapName = ""
const array <string> fogConvars = [
    "fog_enable",
    "fog_enableskybox",
]
const array <string> bloomConvars = [
    "mat_force_bloom",
    "mat_disable_bloom",
    "mat_bloomscale",
    "mat_bloom_wide_amount"
]
const array <string> mapTints = [
    "0.0 0.0 0.0 0.0",
    "0.1 0.0 0.1",
    "0.0 0.05 0.1",
    "0.0 0.0 0.0"
]

void function WGOH_main(){
    if(oldMapName == "mp_wargames"){
        foreach(cvar in fogConvars)
            SetConVarToDefault(cvar)
        foreach(cvar in bloomConvars)
            SetConVarToDefault(cvar)
        SetConVarToDefault("mat_envmap_scale")
        SetConVarToDefault("mat_sun_color")
        SetConVarToDefault("mat_sky_color")
        oldMapName = GetMapName()
    }

    ColorCorrection_SetWeight(wargamesCC, 0.0)

    while(GetMapName() == "mp_wargames"){
        WaitFrame()
        entity player = GetLocalClientPlayer()
        if(!IsValid(player) || player == null)
            continue

        oldMapName = "mp_wargames"

        int mapFog = GetConVarInt("s2_wgoh_map_fog")
        int bloomScale = GetConVarInt("s2_wgoh_bloom_scale")
        int tintNum = GetConVarInt("s2_wgoh_map_tint")
        int ccDisableEntities = GetConVarInt("s2_wgoh_cc_entities")
        float weightCC = GetConVarFloat("s2_wgoh_cc_weight")

        int bloomMulti = 1
        if(bloomScale == 2)
            bloomMulti = 3
        if(bloomScale == 3)
            bloomMulti = 5
        
        ColorCorrection_SetWeight(wargamesCC, weightCC)

        SetConVarInt("mat_colcorrection_disableentities", ccDisableEntities)

        foreach(cvar in fogConvars)
            SetConVarInt(cvar, mapFog)
        SetMapSetting_FogEnabled(mapFog == 1)
        
        if(bloomScale == 0){
            SetConVarInt("mat_force_bloom", 0)
            SetConVarInt("mat_disable_bloom", 1)
        }
        else{
            SetConVarInt("mat_force_bloom", 1)
            SetConVarInt("mat_disable_bloom", 0)
            SetConVarInt("mat_bloomscale", bloomMulti)
            SetConVarFloat("mat_bloom_wide_amount", (0.2 * bloomScale))
        }

        if(GetConVarString("mat_sky_color") != mapTints[tintNum])
            player.ClientCommand("mat_sky_color " + mapTints[tintNum])

        if(GetConVarString("mat_sun_color") != "0 0 0")
            player.ClientCommand("mat_sun_color 0 0 0")

        SetConVarFloat("mat_envmap_scale", 0.25)

        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////        POST PROCESSING END       //////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

        bool doFlicker = (GetConVarInt("s2_wgoh_walls_flicker") == 1)
        bool doKill = (GetConVarInt("s2_wgoh_kill_reactive") == 1)
        bool rgbWalls = (GetConVarInt("s2_wgoh_rgb_walls") == 1)
        bool isLinear = (GetConVarInt("s2_wgoh_kill_type") == 0)
        bool isLogarithmic = (GetConVarInt("s2_wgoh_kill_type") == 1)
        bool isQuadratic = (GetConVarInt("s2_wgoh_kill_type") == 2)
        int flickerPower = GetFlickerPower()
        float baseIntensity = GetConVarFloat("s2_wgoh_base_intensity")
        float killIntensity = GetConVarFloat("s2_wgoh_kill_intensity")
        float killTime = GetConVarFloat("s2_wgoh_kill_time")
        float flickerAmount = GetConVarFloat("s2_wgoh_flicker_deviation")
        float logCoefficient = GetLogCoefficient()
        vector wallOneColour = GetConVarFloat3("s2_wgoh_wall_1_col")
        vector wallTwoColour = GetConVarFloat3("s2_wgoh_wall_2_col")
        vector wallOneKillColour = GetConVarFloat3("s2_wgoh_wall_1_kill_col")
        vector wallTwoKillColour = GetConVarFloat3("s2_wgoh_wall_2_kill_col")

        float IntensityFinal = baseIntensity
        vector WallOneFinalCol = wallOneColour
        vector WallTwoFinalCol = wallTwoColour

        if(rgbWalls){
            vector rainbow
            rainbow.x = (0.5*sin(((0.5*Time()) + 0.0/3.0) * 2 * PI) + 0.5)
            rainbow.y = (0.5*sin(((0.5*Time()) + 1.0/3.0) * 2 * PI) + 0.5)
            rainbow.z = (0.5*sin(((0.5*Time()) + 2.0/3.0) * 2 * PI) + 0.5)
            WallOneFinalCol = rainbow
            WallTwoFinalCol = rainbow
        }

        if(GetConVarInt("s2_wgoh_kill_test_cvar") == 1){
            killStartTime = Time()
            SetConVarInt("s2_wgoh_kill_test_cvar", 0)
        }
        
        if(doKill && !rgbWalls){
            float elapsedTime = (Time() - killStartTime)
            if(elapsedTime <= killTime){
                float timeFrac = (elapsedTime/killTime)
                float chargeFrac = (1 - timeFrac)
                if(isLinear){
                    WallOneFinalCol = ((chargeFrac*wallOneKillColour) + (timeFrac*wallOneColour))
                    WallTwoFinalCol = ((chargeFrac*wallTwoKillColour) + (timeFrac*wallTwoColour))
                    IntensityFinal = ((killIntensity - baseIntensity) * (chargeFrac) + baseIntensity)
                }
                if(isLogarithmic){
                    float timeFracLog = logAnyDecrease(timeFrac, logCoefficient)
                    WallOneFinalCol = ((timeFracLog*wallOneKillColour) + ((1 - timeFracLog)*wallOneColour))
                    WallTwoFinalCol = ((timeFracLog*wallTwoKillColour) + ((1 - timeFracLog)*wallTwoColour))
                    IntensityFinal = ((killIntensity*timeFracLog) + ((1-timeFracLog)*baseIntensity))
                }
                if(isQuadratic){
                    float chargeFracQuad = quadraticDecrease(chargeFrac)
                    WallOneFinalCol = ((chargeFracQuad*wallOneKillColour) + ((1 - chargeFracQuad)*wallOneColour))
                    WallTwoFinalCol = ((chargeFracQuad*wallTwoKillColour) + ((1 - chargeFracQuad)*wallTwoColour))
                    IntensityFinal = (killIntensity*chargeFracQuad) + ((1-chargeFracQuad)*baseIntensity)
                }
            }
        }

        if(doFlicker){
            float upperCap = (1 + flickerAmount)
            float bottomCap = (1 - flickerAmount)
            float flickerOne = flickerPowerFunc(RandomFloatRange(bottomCap, upperCap), flickerPower)
            float flickerTwo = flickerPowerFunc(RandomFloatRange(bottomCap, upperCap), flickerPower)
            WallOneFinalCol = (WallOneFinalCol * flickerOne)
            WallTwoFinalCol = (WallTwoFinalCol * flickerTwo)
        }

        WallOneFinalCol = (WallOneFinalCol * IntensityFinal)
        WallTwoFinalCol = (WallTwoFinalCol * IntensityFinal)

        SetWallColours(WallOneFinalCol, WallTwoFinalCol)

        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////        WALLS END       ////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

        bool gridRGB = (GetConVarInt("s2_wgoh_grid_rgb") == 1)
        vector gridColour = GetConVarFloat3("s2_wgoh_grid_colour")
        float gridIntensity = GetConVarFloat("s2_wgoh_grid_intensity")

        vector GridFinalCol = gridColour

        if(gridRGB){
            GridFinalCol.x = (0.5*sin(((0.5*Time()) + 0.0/3.0) * 2 * PI) + 0.5)
            GridFinalCol.y = (0.5*sin(((0.5*Time()) + 1.0/3.0) * 2 * PI) + 0.5)
            GridFinalCol.z = (0.5*sin(((0.5*Time()) + 2.0/3.0) * 2 * PI) + 0.5)
        }

        SetGridColour(GridFinalCol * gridIntensity)

        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////        GRID END       /////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    }
}

#endif